## org.firebirdsql.jdbc
Class FBArray

    java.lang.Object
      org.firebirdsql.jdbc.FBArray

All Implemented Interfaces:
  Array

    public class FBArray

extends Object
implements Array

A Firebird-specific implementation of the mapping of a java.sql.Array.

Version:
  1.0
Author:
  David Jencks
See Also:
  `Array`

Constructor Summary
`FBArray()`

Method Summary
`void` `free()`
`Object` `getArray()` Retrieves the contents of the SQL `ARRAY` value designated by this `Array` object in the form of an array in the Java programming language.
`Object` `getArray(long index, int count)` Returns an array containing a slice of the SQL `ARRAY` value designated by this `Array` object, beginning with the specified `index` and containing up to `count` successive elements of the SQL array.
`Object` `getArray(long index, int count, Map map)` Returns an array containing a slice of the SQL array object designated by this `Array` object, beginning with the specified `index` and containing up to `count` successive elements of the SQL array.
`Object` `getArray(Map map)` Retrieves the contents of the SQL array designated by this `Array` object.
`int` `getBaseType()` Returns the JDBC type of the elements in the array designated by this `Array` object.
`String` `getBaseTypeName()` Returns the SQL type name of the elements in the array designated by this `Array` object.
`ResultSet` `getResultSet()` Returns a result set that contains the elements of the SQL `ARRAY` value designated by this `Array` object.
`ResultSet` `getResultSet(long index, int count)` Returns a result set holding the elements of the subarray that starts at index `index` and contains up to `count` successive elements.
`ResultSet` `getResultSet(long index, int count, Map map)` Returns a result set holding the elements of the subarray that starts at index `index` and contains up to `count` successive elements.
`ResultSet` `getResultSet(Map map)` Returns a result set that contains the elements of the SQL `ARRAY` value designated by this `Array` object.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FBArray

    public FBArray()

Method Detail

### getBaseTypeName

    public String getBaseTypeName()
                           throws SQLException

  Returns the SQL type name of the elements in the array designated by this `Array` object. If the elements are a built-in type, it returns the database-specific type name of the elements. If the elements are a user-defined type (UDT), this method returns the fully-qualified SQL type name.

  Specified by:
    `getBaseTypeName` in interface `Array`
  Returns:
    a `String` that is the database-specific name for a built-in base type or the fully-qualified SQL type name for a base type that is a UDT
  Throws:
    `SQLException` - if an error occurs while attempting to access the type name
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getBaseType

    public int getBaseType()
                    throws SQLException

  Returns the JDBC type of the elements in the array designated by this `Array` object.

  Specified by:
    `getBaseType` in interface `Array`
  Returns:
    a constant from the class `Types` that is the type code for the elements in the array designated by this `Array` object.
  Throws:
    `SQLException` - if an error occurs while attempting to access the base type
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getArray

    public Object getArray()
                    throws SQLException

  Retrieves the contents of the SQL `ARRAY` value designated by this `Array` object in the form of an array in the Java programming language. This version of the method `getArray` uses the type map associated with the connection for customizations of the type mappings.

  Specified by:
    `getArray` in interface `Array`
  Returns:
    an array in the Java programming language that contains the ordered elements of the SQL `ARRAY` value designated by this object
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getArray

    public Object getArray(Map map)
                    throws SQLException

  Retrieves the contents of the SQL array designated by this `Array` object. This method uses the specified `map` for type map customizations unless the base type of the array does not match a user-defined type in `map`, in which case it uses the standard mapping. This version of the method `getArray` uses either the given type map or the standard mapping; it never uses the type map associated with the connection.

  Specified by:
    `getArray` in interface `Array`
  Parameters:
    `map` - a `java.util.Map` object that contains mappings of SQL type names to classes in the Java programming language
  Returns:
    an array in the Java programming language that contains the ordered elements of the SQL array designated by this object
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getArray

    public Object getArray(long index,
                           int count)
                    throws SQLException

  Returns an array containing a slice of the SQL `ARRAY` value designated by this `Array` object, beginning with the specified `index` and containing up to `count` successive elements of the SQL array. This method uses the type map associated with the connection for customizations of the type mappings.

  Specified by:
    `getArray` in interface `Array`
  Parameters:
    `index` - the array index of the first element to retrieve; the first element is at index 1
    `count` - the number of successive SQL array elements to retrieve
  Returns:
    an array containing up to `count` consecutive elements of the SQL array, beginning with element `index`
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getArray

    public Object getArray(long index,
                           int count,
                           Map map)
                    throws SQLException

  Returns an array containing a slice of the SQL array object designated by this `Array` object, beginning with the specified `index` and containing up to `count` successive elements of the SQL array.

  This method uses the specified `map` for type map customizations unless the base type of the array does not match a user-defined type in `map`, in which case it uses the standard mapping. This version of the method `getArray` uses either the given type map or the standard mapping; it never uses the type map associated with the connection.

  Specified by:
    `getArray` in interface `Array`
  Parameters:
    `index` - the array index of the first element to retrieve; the first element is at index 1
    `count` - the number of successive SQL array elements to retrieve
    `map` - a `java.util.Map` object that contains SQL type names and the classes in the Java programming language to which they are mapped
  Returns:
    an array containing up to `count` consecutive elements of the SQL array designated by this `Array` object, beginning with element `index`.
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

  Returns a result set that contains the elements of the SQL `ARRAY` value designated by this `Array` object. If appropriate, the elements of the array are mapped using the connection's type map; otherwise, the standard mapping is used.

  The result set contains one row for each array element, with two columns in each row. The second column stores the element value; the first column stores the index into the array for that element (with the first array element being at index 1). The rows are in ascending order corresponding to the order of the indices.

  Specified by:
    `getResultSet` in interface `Array`
  Returns:
    a `ResultSet` object containing one row for each of the elements in the array designated by this `Array` object, with the rows in ascending order based on the indices.
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getResultSet

    public ResultSet getResultSet(Map map)
                           throws SQLException

  Returns a result set that contains the elements of the SQL `ARRAY` value designated by this `Array` object. This method uses the specified `map` for type map customizations unless the base type of the array does not match a user-defined type in `map`, in which case it uses the standard mapping. This version of the method `getResultSet` uses either the given type map or the standard mapping; it never uses the type map associated with the connection.

  The result set contains one row for each array element, with two columns in each row. The second column stores the element value; the first column stores the index into the array for that element (with the first array element being at index 1). The rows are in ascending order corresponding to the order of the indices.

  Specified by:
    `getResultSet` in interface `Array`
  Parameters:
    `map` - contains the mapping of SQL user-defined types to classes in the Java programming language
  Returns:
    a `ResultSet` object containing one row for each of the elements in the array designated by this `Array` object, with the rows in ascending order based on the indices.
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getResultSet

    public ResultSet getResultSet(long index,
                                  int count)
                           throws SQLException

  Returns a result set holding the elements of the subarray that starts at index `index` and contains up to `count` successive elements. This method uses the connection's type map to map the elements of the array if the map contains an entry for the base type. Otherwise, the standard mapping is used.

  The result set has one row for each element of the SQL array designated by this object, with the first row containing the element at index `index`. The result set has up to `count` rows in ascending order based on the indices. Each row has two columns: The second column stores the element value; the first column stores the index into the array for that element.

  Specified by:
    `getResultSet` in interface `Array`
  Parameters:
    `index` - the array index of the first element to retrieve; the first element is at index 1
    `count` - the number of successive SQL array elements to retrieve
  Returns:
    a `ResultSet` object containing up to `count` consecutive elements of the SQL array designated by this `Array` object, starting at index `index`.
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getResultSet

    public ResultSet getResultSet(long index,
                                  int count,
                                  Map map)
                           throws SQLException

  Returns a result set holding the elements of the subarray that starts at index `index` and contains up to `count` successive elements. This method uses the specified `map` for type map customizations unless the base type of the array does not match a user-defined type in `map`, in which case it uses the standard mapping. This version of the method `getResultSet` uses either the given type map or the standard mapping; it never uses the type map associated with the connection.

  The result set has one row for each element of the SQL array designated by this object, with the first row containing the element at index `index`. The result set has up to `count` rows in ascending order based on the indices. Each row has two columns: The second column stores the element value; the first column stroes the index into the array for that element.

  Specified by:
    `getResultSet` in interface `Array`
  Parameters:
    `index` - the array index of the first element to retrieve; the first element is at index 1
    `count` - the number of successive SQL array elements to retrieve
    `map` - the `Map` object that contains the mapping of SQL type names to classes in the Java(tm) programming language
  Returns:
    a `ResultSet` object containing up to `count` consecutive elements of the SQL array designated by this `Array` object, starting at index `index`.
  Throws:
    `SQLException` - if an error occurs while attempting to access the array
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### free

    public void free()
              throws SQLException

  Specified by:
    `free` in interface `Array`
  Throws:
    `SQLException`

Copyright © 2001-2010. All Rights Reserved.